# -*- coding: utf-8 -*-
"""
Created on Sat Jan 22 10:30:41 2022

@author: frede
"""
#Programme testant la différence de résultat sur l'oscillateur harmonique 
#entre la méthode d'Euler explicite et la méthode d'Euler implicite
# Equation : d²x/dt² = -wo².x soit avec v = dx/dt  {v=dx/dt ; dv/dt = -wo².x}

#Euler explicite : les variations sont calculées à chaque pas, 
# indépendamment l'une de l'autre, à partir des valeurs antérieures des grandeurs
# l'approximation numérique consécutive à cette méthode s'accumule de pas en pas,
# et amène une solution numérique qui diverge par rapport à la solution exacte (sinusoïdale).

from scipy import *
from pylab import *

deltat=0.1
wo=1
x0=3
v0=0
tmax = 30
t=0
x = x0
v=v0

position=[x0]
vitesse=[v0]
temps=[0]
clf()
while t<tmax:
    t = t + deltat
    dv=-wo**2*(x)*deltat
    dx=v*deltat
    v = v + dv
    x = x + dx
    temps.append(t)
    position.append(x)
    vitesse.append(v)
plot(temps,position)
show()

#Euler implicite : le système étant scindé en deux équations différentielles, 
# la variation de la seconde variable est calculée en tenant compte de la valeur 
# atteinte par la seconde variable en fin de pas.
# Ceci apporte une bien meilleure convergence vers la solution exacte (sinusoïdale).
from scipy import *
from pylab import *

deltat=0.1
wo=1
x0=3
v0=0
tmax = 30
t=0
x = x0
v=v0

position=[x0]
vitesse=[v0]
temps=[0]
clf()
while t<tmax:
    t = t + deltat
    x=x+v*deltat
    v=v-wo**2*(x)*deltat
    temps.append(t)
    position.append(x)
    vitesse.append(v)
plot(temps,position)
show()

#La convergence vers la soution exacte est tout aussi satisfaiante 
#en inversant l'ordre de la déterlination des variations dx et dv dans l boucle.

from scipy import *
from pylab import *

deltat=0.1
wo=1
x0=3
v0=0
tmax = 30
t=0
x = x0
v=v0

position=[x0]
vitesse=[v0]
temps=[0]
clf()
while t<tmax:
    t = t + deltat
    v=v-wo**2*(x)*deltat
    x=x+v*deltat
    temps.append(t)
    position.append(x)
    vitesse.append(v)
plot(temps,position)
show()
